import { prisma } from "@/module/_global";
import { funGetUserByCookies } from "@/module/auth";
import { createLogUser } from "@/module/user";
import { NextResponse } from "next/server";

// ADD LINK PROJECT
export async function POST(request: Request, context: { params: { id: string } }) {
   try {
      const user = await funGetUserByCookies()
      if (user.id == undefined) {
         return NextResponse.json({ success: false, message: "Anda harus login untuk mengakses ini" }, { status: 401 });
      }

      const { id } = context.params
      const { link } = (await request.json())

      const data = await prisma.project.count({
         where: {
            id: id
         }
      })

      if (data == 0) {
         return NextResponse.json(
            {
               success: false, message: "Gagal mendapatkan kegiatan, data tidak ditemukan",
            },
            { status: 404 }
         );
      }


      const insertLink = await prisma.projectLink.create({
         data: {
            idProject: id,
            link: link
         }
      })

      // create log user
      const log = await createLogUser({ act: 'CREATE', desc: 'User menambah link kegiatan', table: 'projectLink', data: insertLink.id })
      return NextResponse.json({ success: true, message: "Berhasil menambahkan link kegiatan" }, { status: 200 });

   } catch (error) {
      console.error(error);
      return NextResponse.json({ success: false, message: "Gagal menambah link kegiatan, coba lagi nanti (error: 500)", reason: (error as Error).message, }, { status: 500 });
   }
}


// DELETE LINK PROJECT
export async function DELETE(request: Request, context: { params: { id: string } }) {
   try {
      const user = await funGetUserByCookies()
      if (user.id == undefined) {
         return NextResponse.json({ success: false, message: "Anda harus login untuk mengakses ini" }, { status: 401 });
      }

      const { idLink } = (await request.json())

      const data = await prisma.projectLink.count({
         where: {
            id: idLink
         }
      })

      if (data == 0) {
         return NextResponse.json(
            {
               success: false, message: "Gagal mendapatkan link, data tidak ditemukan",
            },
            { status: 404 }
         );
      }

      const deleteLink = await prisma.projectLink.update({
         where: {
            id: idLink
         },
         data: {
            isActive: false
         }
      })

      // create log user
      const log = await createLogUser({ act: 'DELETE', desc: 'User menghapus link kegiatan', table: 'projectLink', data: String(idLink) })
      return NextResponse.json({ success: true, message: "Berhasil menghapus link kegiatan" }, { status: 200 });

   } catch (error) {
      console.error(error);
      return NextResponse.json({ success: false, message: "Gagal menghapus link kegiatan, coba lagi nanti (error: 500)", reason: (error as Error).message, }, { status: 500 });
   }
}
